pcl::tracking::NearestPairPointCloudCoherence< PointInT > Class Template Reference

NearestPairPointCloudCoherence computes coherence between two pointclouds using the nearest point pairs. More...

`#include <pcl/tracking/nearest_pair_point_cloud_coherence.h>`

Inheritance diagram for pcl::tracking::NearestPairPointCloudCoherence< PointInT >:

## Public Types

using | PointCoherencePtr = typename PointCloudCoherence< PointInT >::PointCoherencePtr
using | PointCloudInConstPtr = typename PointCloudCoherence< PointInT >::PointCloudInConstPtr
using | BaseClass = PointCloudCoherence< PointInT >
using | Ptr = shared_ptr< NearestPairPointCloudCoherence< PointInT > >
using | ConstPtr = shared_ptr< const NearestPairPointCloudCoherence< PointInT > >
using | SearchPtr = typename pcl::search::Search< PointInT >::Ptr
using | SearchConstPtr = typename pcl::search::Search< PointInT >::ConstPtr
Public Types inherited from pcl::tracking::PointCloudCoherence< PointInT >
using | Ptr = shared_ptr< PointCloudCoherence< PointInT > >
using | ConstPtr = shared_ptr< const PointCloudCoherence< PointInT > >
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCoherencePtr = typename PointCoherence< PointInT >::Ptr

## Public Member Functions

| NearestPairPointCloudCoherence ()
| empty constructor More...
void | setSearchMethod (const SearchPtr &search)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
SearchPtr | getSearchMethod ()
| Get a pointer to the point cloud dataset. More...
void | setTargetCloud (const PointCloudInConstPtr &cloud) override
| add a PointCoherence to the PointCloudCoherence. More...
void | setMaximumDistance (double val)
| set maximum distance to be taken into account. More...
Public Member Functions inherited from pcl::tracking::PointCloudCoherence< PointInT >
| PointCloudCoherence ()
| Constructor. More...
virtual | ~PointCloudCoherence ()
| Destructor. More...
void | compute (const PointCloudInConstPtr &cloud, const IndicesConstPtr &indices, float &w_i)
| compute coherence between two pointclouds. More...
std::vector< PointCoherencePtr > | getPointCoherences ()
| get a list of pcl::tracking::PointCoherence. More...
void | setPointCoherences (std::vector< PointCoherencePtr > coherences)
| set a list of pcl::tracking::PointCoherence. More...
void | addPointCoherence (PointCoherencePtr coherence)
| add a PointCoherence to the PointCloudCoherence. More...

## Protected Member Functions

bool | initCompute () override
| This method should get called before starting the actual computation. More...
void | computeCoherence (const PointCloudInConstPtr &cloud, const IndicesConstPtr &indices, float &w_j) override
| compute the nearest pairs and compute coherence using point_coherences_ More...
Protected Member Functions inherited from pcl::tracking::PointCloudCoherence< PointInT >
double | calcPointCoherence (PointInT &source, PointInT &target)
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...

## Protected Attributes

bool | new_target_
| A flag which is true if target_input_ is updated. More...
SearchPtr | search_
| A pointer to the spatial search object. More...
double | maximum_distance_
| max of distance for points to be taken into account More...
Protected Attributes inherited from pcl::tracking::PointCloudCoherence< PointInT >
std::string | coherence_name_
| The coherence name. More...
PointCloudInConstPtr | target_input_
| a pointer to target point cloud More...
std::vector< PointCoherencePtr > | point_coherences_
| a list of pointers to PointCoherence. More...

## Detailed Description

### template<typename PointInT>
class pcl::tracking::NearestPairPointCloudCoherence< PointInT >

NearestPairPointCloudCoherence computes coherence between two pointclouds using the nearest point pairs.

Author
  Ryohei Ueda

Definition at line 17 of file nearest_pair_point_cloud_coherence.h.

## Member Typedef Documentation

## BaseClass

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::BaseClass = PointCloudCoherence<PointInT>

Definition at line 26 of file nearest_pair_point_cloud_coherence.h.

## ConstPtr

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::ConstPtr = shared_ptr<const NearestPairPointCloudCoherence<PointInT> >

Definition at line 29 of file nearest_pair_point_cloud_coherence.h.

## PointCloudInConstPtr

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::PointCloudInConstPtr = typename PointCloudCoherence<PointInT>::PointCloudInConstPtr

Definition at line 25 of file nearest_pair_point_cloud_coherence.h.

## PointCoherencePtr

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::PointCoherencePtr = typename PointCloudCoherence<PointInT>::PointCoherencePtr

Definition at line 24 of file nearest_pair_point_cloud_coherence.h.

## Ptr

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::Ptr = shared_ptr<NearestPairPointCloudCoherence<PointInT> >

Definition at line 28 of file nearest_pair_point_cloud_coherence.h.

## SearchConstPtr

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::SearchConstPtr = typename pcl::search::Search<PointInT>::ConstPtr

Definition at line 31 of file nearest_pair_point_cloud_coherence.h.

## SearchPtr

template<typename PointInT>

using pcl::tracking::NearestPairPointCloudCoherence< PointInT >::SearchPtr = typename pcl::search::Search<PointInT>::Ptr

Definition at line 30 of file nearest_pair_point_cloud_coherence.h.

## Constructor & Destructor Documentation

## NearestPairPointCloudCoherence()

template<typename PointInT>

pcl::tracking::NearestPairPointCloudCoherence< PointInT >::NearestPairPointCloudCoherence | ( |  | ) |

inline

empty constructor

Definition at line 34 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::PointCloudCoherence< PointInT >::coherence_name_.

## Member Function Documentation

## computeCoherence()

template<typename PointInT >

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::computeCoherence | ( | const PointCloudInConstPtr & | cloud,
|  | const IndicesConstPtr & | indices,
|  | float & | w_j
| ) |  |

override protected virtual

compute the nearest pairs and compute coherence using point_coherences_

Implements pcl::tracking::PointCloudCoherence< PointInT >.

Definition at line 13 of file nearest_pair_point_cloud_coherence.hpp.

## getSearchMethod()

template<typename PointInT>

SearchPtr pcl::tracking::NearestPairPointCloudCoherence< PointInT >::getSearchMethod | ( |  | ) |

inline

Get a pointer to the point cloud dataset.

Definition at line 54 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::search_.

## initCompute()

template<typename PointInT >

bool pcl::tracking::NearestPairPointCloudCoherence< PointInT >::initCompute | ( |  | ) |

override protected virtual

This method should get called before starting the actual computation.

Reimplemented from pcl::tracking::PointCloudCoherence< PointInT >.

Definition at line 45 of file nearest_pair_point_cloud_coherence.hpp.

## setMaximumDistance()

template<typename PointInT>

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setMaximumDistance | ( | double | val | ) |

inline

set maximum distance to be taken into account.

Parameters

  [in] | val | maximum distance.

Definition at line 69 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::maximum_distance_.

## setSearchMethod()

template<typename PointInT>

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setSearchMethod | ( | const SearchPtr & | search | ) |

inline

Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.

This is optional, if this is not set, it will only use the data in the input cloud to estimate the features. This is useful when you only need to compute the features for a downsampled cloud.

Parameters

  search | a pointer to a PointCloud message

Definition at line 50 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::search_.

## setTargetCloud()

template<typename PointInT>

void pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setTargetCloud | ( | const PointCloudInConstPtr & | cloud | ) |

inline override virtual

add a PointCoherence to the PointCloudCoherence.

Parameters

  [in] | cloud | coherence a pointer to PointCoherence.

Reimplemented from pcl::tracking::PointCloudCoherence< PointInT >.

Definition at line 60 of file nearest_pair_point_cloud_coherence.h.

References pcl::tracking::NearestPairPointCloudCoherence< PointInT >::new_target_, and pcl::tracking::PointCloudCoherence< PointInT >::setTargetCloud().

## Member Data Documentation

## maximum_distance_

template<typename PointInT>

double pcl::tracking::NearestPairPointCloudCoherence< PointInT >::maximum_distance_

protected

max of distance for points to be taken into account

Definition at line 84 of file nearest_pair_point_cloud_coherence.h.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setMaximumDistance().

## new_target_

template<typename PointInT>

bool pcl::tracking::NearestPairPointCloudCoherence< PointInT >::new_target_

protected

A flag which is true if target_input_ is updated.

Definition at line 78 of file nearest_pair_point_cloud_coherence.h.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setTargetCloud().

## search_

template<typename PointInT>

SearchPtr pcl::tracking::NearestPairPointCloudCoherence< PointInT >::search_

protected

A pointer to the spatial search object.

Definition at line 81 of file nearest_pair_point_cloud_coherence.h.

Referenced by pcl::tracking::NearestPairPointCloudCoherence< PointInT >::getSearchMethod(), and pcl::tracking::NearestPairPointCloudCoherence< PointInT >::setSearchMethod().

The documentation for this class was generated from the following files:

- pcl/tracking/nearest_pair_point_cloud_coherence.h
- pcl/tracking/impl/nearest_pair_point_cloud_coherence.hpp